#! /bin/bash

# Read in language file
source ${BBROOTDIR}/lang/${BBLANG}/audio_menu.lang

# A little wait function
wait_for_enter()
{
while true; do
	echo -e $bb_am_enter_1
	read temp
	if [[ "$temp" = "" ]]; then
		break
	else
		continue
	fi
done
}

#This function lets you swap cds if you only have one device.
#(CDwriter and CDreader is same device.)
insert_new_CD()
{
        while true; do
                echo $bb_am_enter_2
                read temp
                if [[ "$temp" = "" ]]; then
                        break
                else
                        continue
                fi
        done
}

# A little function that looks for mp3s

check_for_mp3s()
{
	cd ${BBBURNDIR}
	while read MPTHREE; do
        	existing="yes"
	done < <(find ${BBBURNDIR} -iname "*.mp3" | sort)

	if [[ "$existing" != "yes" ]]; then
        	echo
        	echo "$bb_am_nomp3s${BBBURNDIR}"
	else
		${BBROOTDIR}/convert/convert_mp3s.sh
	fi
}

# A function that checks for ogg files

check_for_oggs()
{
	cd ${BBBURNDIR}
	while read OGGS; do
		existing="yup"
	done < <(find ${BBBURNDIR} -iname "*.ogg" | sort)

	if [[ "$existing" != "yup" ]]; then
        	echo
        	echo "$bb_am_nooggs${BBBURNDIR}"
	else
		${BBROOTDIR}/convert/convert_oggs.sh	
	fi
}

# A function that checks for flac files

check_for_flacs()
{
	cd ${BBBURNDIR}
	while read FLACS; do
		existing="aight"
	done < <(find ${BBBURNDIR} -iname "*.flac" | sort)

	if [[ "$existing" != "aight" ]]; then
		echo
		echo "$bb_am_noflacs${BBBURNDIR}"
	else
		${BBROOTDIR}/convert/convert_flacs.sh
	fi
}

# A function that adjust the volume of wav
# audio files to a standard volume level.

normalization()
{
        if [[ "$BBNORMALIZE" = "yes" ]]; then
                cd ${BBBURNDIR}
                for i in *.wav; do
		   echo;echo -e "${BBTABLECOLOR}|>${BBSUBCOLOR}$bb_am_norm_1$i...${BBCOLOROFF}";
                   normalize -v -m $i;
                done
        fi
}

# Function that valide the input of "y" or "n".

conf_yes_no()
{
	unset ANSWER
	while [ "${ANSWER}" != 'y' ] && [ "${ANSWER}" != 'n' ]
	do 
		echo -n $bb_am_conf_2
		read ANSWER
	done

}

# Function that control errors.

conf_error()
{
	STDERROR=$?
	# If there is any error return to main menu.
	if [[ ${STDERROR} -ne 0 ]]; then
		echo -e "${BBTABLECOLOR}$bb_am_err_1${BBCOLOROFF}"
		sleep 3
		exit
	fi
}	


# Simple function that valide confirmation of song names.

confirmation()
{
	echo
	if [[ ! -f "${BBBURNDIR}/song_name.txt" ]]; then
		exit
	else
		echo -e "${BBTABLECOLOR}|>${BBMAINCOLOR}$bb_am_conf_1${BBCOLOROFF}"
		cat -n ${BBBURNDIR}/song_name.txt
		echo -e "${BBSUBCOLOR}"
		conf_yes_no		# Valid input.
		echo -e "${BBCOLOROFF}"
		
		if [[ ${ANSWER} = 'n' ]];
		then
			rm -f ${BBBURNDIR}/song_name.txt
			rm -f ${BBBURNDIR}/tracks.txt
			exit
		fi
	fi
}

# Function for name at mode interactive.

named()
{
	# Delete old lists of songs rip.
	rm -f ${BBBURNDIR}/*.txt

	# cdda2wav show information of tracks to rip.
	# it's great for see which track would to be 
	# rip and the time of duration of the tracks.
	echo -e "${BBSUBCOLOR}$bb_am_named_1${BBCOLOROFF}"
	sleep 1s
	cdda2wav -D ${BBCDROM} -H -J -v toc

	# If there is any error return to main menu.
	conf_error
	
	TRACK=0
	while [ "${TRACK}" != "" ]; do
		echo;echo -en "${BBMAINCOLOR}$bb_am_named_2"
		echo;echo -en "${BBMAINCOLOR}$bb_am_named_3${BBTABLECOLOR}|>${BBCOLOROFF} "
		read TRACK
	
			if [ "${TRACK}" != "" ];
			then
				# Only permit integer numbers standing the format in the numbers of back prompt.
				number_track=`printf '%02d' ${TRACK}`			
	
				# This line puts track numbers of the input standard into tracks.txt.	
				echo "${number_track}" >> ${BBBURNDIR}/tracks.txt
			else
			# If nothing is entered at the prompt then exit loop.
				continue
			fi

		echo
		echo -e "${BBMAINCOLOR}$bb_am_named_4"
		echo -e "${BBMAINCOLOR}$bb_am_named_5"
		echo -en "${BBMAINCOLOR}$bb_am_named_6${number_track} ${BBTABLECOLOR}|>${BBCOLOROFF} "
		read song_name

		# If the song_name variable = space blank then, change  
		# fill that with the number of the track to ripped.
		if [[ "${song_name}" = "" ]]; then 
			song_name=`echo "${number_track}.-Track"` 
		else
		
		# If the song_name variable contained some signs and caracters specials, 
		# that difficulty the naming in bash shell, to be equal to nothing.
		# Read sed man page to see how it work.
		song_name=`echo "$song_name" | sed -e 's/(//g'		\
					-e 's/)//g' -e 's/*//g' 	\
					-e 's/?//g' -e 's///g' 	\
					-e 's/\///g' -e 's/&//g'`
		fi
		# This line puts song name of the input standard into song_name.txt.	
	     	echo ${song_name} >> ${BBBURNDIR}/song_name.txt
done
}     
	
# Function rip the tracks or songs selects.

rip()
{
	confirmation
	cd ${BBBURNDIR}
	track=0	
	while [ "${track}" != "" ]; do
	
		# Read the track to rip of the files in temp directory.
		track=`sed -ne '1p' ${BBBURNDIR}/tracks.txt`
		if [[ "${track}" = "" ]]; then
			continue
		else
                   	echo -e "${BBTABLECOLOR}|>${BBSUBCOLOR}$bb_am_rip_1${track}...${BBCOLOROFF}"
		
			# Begin Rip.	
			cdda2wav -D ${BBCDROM} -x -t ${track} -O wav ${track} #Changed from cdparanoia to cdda2wav
			sleep 2s
			
			# This two lines add '.wav' to finished of the tracks/song_name variable for rename.
			track=`sed -ne '1p' ${BBBURNDIR}/tracks.txt | sed -e 's/$/.wav/g'`
			song_name=`sed -ne '1p' ${BBBURNDIR}/song_name.txt | sed -e 's/$/.wav/g'`
	
			# Rename the tracks that has been ripped, by the name 
			# get back by users in prompt.
			mv "${track}" "${song_name}"
			
			# Remove the song that has been ripped. 
			sed -e '1d' ${BBBURNDIR}/song_name.txt >> ${BBBURNDIR}/temp_song.txt
			mv ${BBBURNDIR}/temp_song.txt ${BBBURNDIR}/song_name.txt
			sed -e '1d' ${BBBURNDIR}/tracks.txt >> ${BBBURNDIR}/temp_tracks.txt
			mv ${BBBURNDIR}/temp_tracks.txt ${BBBURNDIR}/tracks.txt
		fi
	 done
        # Remove temp files.
	rm -f ${BBBURNDIR}/tracks.txt
	rm -f ${BBBURNDIR}/song_name.txt
	rm -f ${BBBURNDIR}/*.inf
	
	eject ${BBCDROM}
	echo -e "${BBSUBCOLOR}$bb_am_rip_2${BBCOLOROFF}"
	sleep 2s
}     

# Function Encode Filter Command.

encode_filter()
{
	if [[ "$ENCODEFILTER" != "" ]]; then
                echo -e "${BBTABLECOLOR}|>${BBSUBCOLOR}$bb_am_encfilt(${ENCODEFILTER})${BBCOLOROFF}"
		`${ENCODEFILTER} ${BBBURNDIR}/*.${format}`
	fi			
}

####PROGRAM START#####

while true; do
        # <colors>
        BBCOLOROFF="\033[1;0m"    # standard color
        BBHEADCOLOR="\033[1;32m"  # green
        BBMAINCOLOR="\033[1;37m"  # white
        BBSUBCOLOR="\033[1;36m"   # blue
        BBTABLECOLOR="\033[1;31m" # red
        BBINPUTCOLOR="\033[1;35m" # lilac
        # </colors>   
        setterm -clear
        # <table>
        echo -e "${BBTABLECOLOR}${BBDECOLINE}"
        echo -e "${BBTABLECOLOR}|${BBHEADCOLOR} ${BBVERSION} ${BBTABLECOLOR}|"
        echo -e "${BBTABLECOLOR}${BBDECOLINE}"
        echo -e "${BBTABLECOLOR}|"
        echo -e "${BBTABLECOLOR}|-(${BBSUBCOLOR}$bb_am_menu_title${BBTABLECOLOR})"
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 1) $bb_am_menu_1"
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 2) $bb_am_menu_2"
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 3) $bb_am_menu_3"
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 4) $bb_am_menu_4"
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 5) $bb_am_menu_5"
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 6) $bb_am_menu_6"
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 7) $bb_am_menu_7"
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 8) $bb_am_menu_8"
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 9) $bb_am_menu_9"
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 10) $bb_am_menu_10"
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 11) $bb_am_menu_11"
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 0) $bb_am_menu_0"
        echo -e "${BBTABLECOLOR}|"
	echo -n -e "${BBINPUTCOLOR}$bb_am_menu_input[0-11] |>${BBMAINCOLOR} "        
        read action
        echo -e "${BBCOLOROFF}"
        # </table>

 case $action in
                1)      
			# Burn Audio from Mp3s
                        	check_for_mp3s                  # Converting mp3s to wavs
				check_for_oggs			# Converting oggs to wavs
				check_for_flacs			# Converting flacs to wavs
                                ${BBROOTDIR}/burning/burning.sh --audio
				sleep 2s
	        ;;
                2)      
			# Burn Audio Directly
			${BBROOTDIR}/burning/burning.sh --pipeline
			sleep 2s
                ;;
                3)	
			# Copy an audio cd.
			cd ${BBBURNDIR}
                        if cdda2wav -D ${BBCDROM} -v all -B -Owav; then      #Changed from cdparanoia to cdda2wav
                        	eject ${BBCDROM}
                                echo $bb_am_rip_2
				
				# Normalize WAV's.
                                normalization 

                               if [[ ${BBNUMDEV} == 1 ]]; then                     #Check number of devices
                        	        insert_new_CD
                                fi
                                     
				if cdrecord -v dev=${BBCDWRITER} speed=${BBSPEED} \
					${BBOPT_ONE:+"driveropts=$BBOPT_ONE"} ${BBDTAO} \
					-useinfo ${BBBURNDIR}/*.wav; then
                                        echo $bb_am_ch3_1
                                        wait_for_enter
                                else
                                        echo $bb_am_ch3_2
                                        wait_for_enter
				fi
                        else
                                echo "$bb_am_ch3_3${BBCDROM}"
                                wait_for_enter
			fi
       		;;
                4)      
			# Copy an audio cd to HD
			cd ${BBBURNDIR}
                        cdda2wav -D ${BBCDROM} -v all -B -Owav
                        eject ${BBCDROM}

			# Normalize WAV's.
                        normalization

                        echo "$bb_am_ch4_1${BBBURNDIR}.$bb_am_ch4_2"
			echo $bb_am_ch4_3
                        wait_for_enter                
                ;;
		5)	
			# Burn a xmms playlist
			if eval ${BBROOTDIR}/misc/xmmsread.sh; then
				${BBROOTDIR}/burning/burning.sh --audio
			else
				echo $bb_am_ch5
				wait_for_enter
			fi
		;;
		6)
			#Create Mp3s from Wavs in BURNDIR
			cd ${BBBURNDIR}
			
			while read WAV; do
        		echo
			if lame --preset cd "${WAV}" "${WAV%%.wav}.mp3"; then
				echo "${WAV%%.wav}.mp3$bb_am_ch6_1"
			else
				echo "${WAV}:$bb_am_ch6_2"
        		fi
        		echo
        		existing="yes"
			done < <(find "${BBBURNDIR}" -iname "*wav" | sort)

			if [[ "$existing" != "yes" ]]; then
        			echo
        			echo "$bb_am_ch6_3${BBBURNDIR}"	
			else
				# Encode Filter Command. 
				format=mp3
				encode_filter
			fi
			sleep 2s
			continue
		;;
		7)
			#Create Oggs from Wavs in BURNDIR
                        cd ${BBBURNDIR}

                        while read WAV; do
                        echo
                        if oggenc -b ${BBBITRATE} "${WAV}"; then
                                echo $bb_am_ch7_1
                        else
                                echo "${WAV}:$bb_am_ch6_2"
                        fi
                        echo
                        existing="yes"
                        done < <(find "${BBBURNDIR}" -iname "*wav" | sort)

                        if [ "$existing" != "yes" ]; then
                                echo
                                echo "$bb_am_ch6_3${BBBURNDIR}"
                        else
				# Encode Filter Command. 
				format=ogg
				encode_filter
			fi
                        sleep 2s
                        continue
		;;
		8)
			# Create flacs from Wavs in BURNDIR
			cd ${BBBURNDIR}
		
			while read WAV; do
			echo
			if flac "${WAV}"; then
				echo $bb_am_ch7_1
			else
				echo "${WAV}:$bb_am_ch6_2"
			fi
			echo
			existing="yes"
			done < <(find "${BBBURNDIR}" -iname "*wav" | sort)

			if [[ "$existing" != "yes" ]]; then
				echo
				echo "$bb_am_ch6_3${BBBURNDIR}"
			fi

			sleep 2s
			continue
		;;
		9)
			# Create Mp3s from an audio cd.
			#First, name and rip the tracks
			
			# Give name to the tracks.
			named
			
			# Rip the tracks in wav audio file.
			rip
			
			# Normalize WAV's.
	                normalization
			
			#Now create the Mp3s
			
			while read WAV; do
                   	echo;echo -e "${BBTABLECOLOR}|>${BBSUBCOLOR}$bb_am_ch9_1${BBCOLOROFF}"
			
			if lame --preset cd ${WAV} ${WAV%%.wav}.mp3; then
                                echo "${WAV%%.wav}.mp3$bb_am_ch6_1"
                        else
                                echo "${WAV}:$bb_am_ch6_2"
                        fi
                        echo
                        existing="yes"
                        done < <(find "$BURNDIR" -iname "*wav" | sort)
			
			if [[ "$existing" != "yes" ]]; then
                                echo
                                echo "$bb_am_ch6_3${BBBURNDIR}"
                        	sleep 2s
				continue
                        else
				# Encode Filter Command. 
				format=mp3
				encode_filter
			fi
			
			echo "$bb_am_ch9_2${BBBURNDIR}"
                        rm ${BBBURNDIR}/*.wav
			wait_for_enter
		;;
		10)
			# Create Oggs from an audio cd.
                        #First, name and rip the tracks

			# Give name to the tracks.
			named
			
			# Rip the tracks in wav audio file.
			rip
			
			# Normalize WAV's.
	                normalization
                        
			#Now create the Oggs.
			
			while read WAV; do
                   	echo;echo -e "${BBTABLECOLOR}|>${BBSUBCOLOR}$bb_am_ch10_1${BBCOLOROFF}"
                        if oggenc -b ${BBBITRATE} "${WAV}"; then
                                echo $bb_am_ch7_1
                        else
                                echo "${WAV}:$bb_am_ch6_2"
                        fi
                        echo
                        existing="yes"
                        done < <(find "${BBBURNDIR}" -iname "*wav" | sort)

                        if [[ "$existing" != "yes" ]]; then
                                echo
                                echo "$bb_am_ch6_3${BBBURNDIR}"
                        	sleep 2s
				continue
			else
				# Encode Filter Command. 
                        	format=ogg
				encode_filter	
			fi

			echo "$bb_am_ch10_2${BBBURNDIR}"
			rm ${BBBURNDIR}/*.wav
			wait_for_enter
		;;
		11)
			# Create flacs from cd
			# Give name to the tracks.
			named
			
			# Rip the tracks in wav audio file.
			rip
			
			# Normalize WAV's.
	                normalization
                        
			# Now create Flacs
			
			while read WAV; do
			echo
			if flac "${WAV}"; then
				echo $bb_am_ch7_1
			else
				echo "${WAV}:$bb_am_ch6_2"
			fi
			echo
			existing="yes"
			done < <(find "${BBBURNDIR}" -iname "*wav" | sort)

			if [[ "$existing" != "yes" ]]; then
				echo
				echo "$bb_am_ch6_3${BBBURNDIR}"
				sleep 2s
				continue
			else
				# Function Encode Filter Command. 
                        	format=flac
				encode_filter	
			fi

			echo "$bb_am_ch11_1${BBBURNDIR}"
			rm ${BBBURNDIR}/*.wav
			wait_for_enter			
		;;
		0)      # Abort
                        echo $bb_am_ch0
                        break
                ;;
                *)
                        echo "$bb_am_error[0-11]"
                        sleep 1s
                        continue                                #Else go to menu
                ;;
        esac
done
