#! /bin/bash

# Read in language
source ${BBROOTDIR}/lang/${BBLANG}/iso_menu.lang

# A small wait function
wait_for_enter()
{
while true; do
	echo $bb_im_wait_1
	read temp
	if [[ "$temp" = "" ]]; then
		break
	else
		continue
	fi
done
}


####PROGRAM START#####
while true; do
        # <colors>
        BBCOLOROFF="\033[1;0m"    # standard color
        BBHEADCOLOR="\033[1;32m"  # green
        BBMAINCOLOR="\033[1;37m"  # white
        BBSUBCOLOR="\033[1;36m"   # blue
        BBTABLECOLOR="\033[1;31m" # red
        BBINPUTCOLOR="\033[1;35m" # lilac
        # </colors>
        setterm -clear
        # <table>
        echo -e "${BBTABLECOLOR}${BBDECOLINE}"
        echo -e "${BBTABLECOLOR}|${BBHEADCOLOR} ${BBVERSION} ${BBTABLECOLOR}|"
        echo -e "${BBTABLECOLOR}${BBDECOLINE}"
        echo -e "${BBTABLECOLOR}|"
        echo -e "${BBTABLECOLOR}|-(${BBSUBCOLOR}$bb_im_menu_title${BBTABLECOLOR})"
        echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 1) $bb_im_menu_1"
        echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 2) $bb_im_menu_2${BBBURNDIR}"
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 3) $bb_im_menu_3"
        echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 0) $bb_im_menu_0"
        echo -e "${BBTABLECOLOR}|"
	echo -n -e "${BBINPUTCOLOR}$bb_im_menu_entry[0-3] |>${BBMAINCOLOR} "
        read action
        echo -e "${BBCOLOROFF}"
        # </table>

 case $action in
		1)      # Burn ISO
			"${BBROOTDIR}"/burning/burning.sh --iso
			break
                ;;
		2)	#Create ISO from BBBURNDIR
			# Does an ISO file exist?
			if ls ${BBBURNDIR} | grep "\.iso$"&> /dev/null; then
			#if $(find ${BBBURNDIR} -iname "*iso") != "" &> /dev/null; then
				echo "$bb_im_ch2_1${BBBURNDIR}.$bb_im_ch2_2"
				echo $bb_im_ch2_3
				wait_for_enter
				continue
			else
				# Creating ISO from files
				echo; echo $bb_im_ch2_4
                        if eval "mkisofs -r -f -v -J -hide-joliet-trans-tbl -copyright \"$BBCOPYRIGHT\" \
				-A \"$BBDESCRIPTION\" -p \"$BBAUTHOR\" -publisher \"$BBPUBLISHER\" \
				-volset \"$BBNAMEOFPACKAGE\" -V \"$BBLABEL\" \
				-o ${BBBURNDIR}/BashBurn.iso ${BBBURNDIR}"; then
                                echo $bb_im_ch2_5
                                wait_for_enter
                                continue
                        else		#Some error occured
				echo $bb_im_ch2_6
				echo $bb_im_ch2_7
                                wait_for_enter
				break
			fi
			
			fi

                ;;
		3)	# Create ISO from cd
			# Does an ISO file exist?
			if ls ${BBBURNDIR} | grep "\.iso$" &> /dev/null; then
                                echo "$bb_im_ch2_1${BBBURNDIR}.$bb_ch2_2"
                                echo $bb_im_ch2_3
                                wait_for_enter
                                break
			elif grep /mnt/dvd /etc/mtab &> /dev/null; then
				echo "$bb_im_ch3_2${BBCDMNT}"
				# Creating ISO using mkisofs       
                                if mkisofs -o ${BBBURNDIR}/BashBurn.iso -f ${BBCDMNT}; then
					echo $bb_im_ch2_4
					wait_for_enter
                                else
                                        echo $bb_im_ch2_6
                                        echo $bb_im_ch2_7
					wait_for_enter
					break
				fi
                                sleep 2s                                        # Pause so you can see message
                                continue
			else
				echo "${BBCDMNT}$bb_im_ch3_1"
                                wait_for_enter
				continue
                        fi
		;;
		0)      # Quit
                        echo $bb_im_ch0
                        break
                ;;
                *)	#You chose wrong stupid!
                        echo "$bb_im_error[0-3]"
                        sleep 1s
                        continue
                ;;
        esac
done
