#! /bin/bash

# Read in language
source ${BBROOTDIR}/lang/${BBLANG}/mount.lang

#####PROGRAM START#####
while true; do
        # <colors>
        BBCOLOROFF="\033[1;0m"    # standard color
        BBHEADCOLOR="\033[1;32m"  # green
        BBMAINCOLOR="\033[1;37m"  # white
        BBSUBCOLOR="\033[1;36m"   # blue
        BBTABLECOLOR="\033[1;31m" # red
        BBINPUTCOLOR="\033[1;35m" # lilac
        # </colors>
        setterm -clear
        # <table>
        echo -e "${BBTABLECOLOR}${BBDECOLINE}"
        echo -e "${BBTABLECOLOR}|${BBHEADCOLOR} ${BBVERSION} ${BBTABLECOLOR}|"
        echo -e "${BBTABLECOLOR}${BBDECOLINE}"
        echo -e "${BBTABLECOLOR}|"
        echo -e "${BBTABLECOLOR}|-(${BBSUBCOLOR}$bb_mnt_menu_title${BBTABLECOLOR})"
        echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 1) $bb_mnt_menu_1"
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 2) $bb_mnt_menu_2"
	echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 3) $bb_mnt_menu_3"
        echo -e "${BBTABLECOLOR}|${BBMAINCOLOR} 0) $bb_mnt_menu_0"
        echo -e "${BBTABLECOLOR}|"
	echo -n -e "${BBINPUTCOLOR}$bb_mnt_menu_input[0-3] |>${BBMAINCOLOR} "
        read action
        echo -e "${BBCOLOROFF}"
        # </table>

 case $action in
                1)      # Mount device
                        cat /etc/fstab | grep cdrom | sort
			echo; echo $bb_mnt_ch1_1
			echo $bb_mnt_ch1_2
			echo $bb_mnt_ch1_3
			echo $bb_mnt_ch1_4
			echo -n "|> "
			read BBDEVICE
			if [[ "${BBDEVICE}" == "" ]]; then
				echo $bb_mnt_ch1_5
                                sleep 2s
                                continue
			else
				echo "$bb_mnt_ch1_6${BBDEVICE}..."
				if mount ${BBDEVICE} &> /dev/null; then
					echo "${BBDEVICE}$bb_mnt_ch1_7"
					sleep 2s
					continue
				else
					echo $bb_mnt_ch1_8
					echo $bb_mnt_ch1_9
					echo $bb_mnt_ch1_10
					sleep 3s
					continue
				fi
			fi
                ;;
		2)	# Unmount device
			if [[ "$(cat /etc/mtab | grep cdrom)" == "" ]]; then
				echo $bb_mnt_ch2_1
				sleep 3s
			else
				cat /etc/mtab | grep cdrom | sort
				echo; echo $bb_mnt_ch2_2
				echo -n "|> "
				read DEVICE
				if umount ${BBDEVICE} &> /dev/null; then
					echo "${BBDEVICE}$bb_mnt_ch2_3"
					sleep 2s
					continue
				else
					echo $bb_mnt_ch2_4
					echo $bb_mnt_ch2_5
					sleep 3s
					continue
				fi
			fi
		;;
		3)
			# Eject device
			cat /etc/fstab | grep cdrom | sort
			echo $bb_mnt_ch3_1
			echo $bb_mnt_ch3_1b
			echo -n "|> "
			read BBDEVICE
			if [[ $BBDEVICE == "" ]]; then
				echo $bb_mnt_ch3_1c
				sleep 2s
				continue
			else
				if eject ${BBDEVICE} &> /dev/null; then
					echo "${BBDEVICE}$bb_mnt_ch3_2"
					sleep 2s
					continue
				else
					echo $bb_mnt_ch3_3
					echo $bb_mnt_ch3_4
					sleep 3s
					continue
				fi
			fi
		;;
		0)	# Back to main
			echo $bb_mnt_ch0
			sleep 1s
			break
		;;
		*)
			echo "$bb_mnt_error[0-3]"
			sleep 1s
			continue
		;;
	esac
done
